# $Id: polyshrink.R,v 1.2 2005/08/15 16:40:37 bob Exp $
"polyshrink" <-
function(z) {
	big.in <- abs(z)>30;    	# avoid overflow for big ones
	big <- z[big.in];
	z[big.in] <- 30;            # sign does not matter
	n <- length(z);
	k <- 1 + floor(log2(n));    # number of summands
	eps <- 2^(-(k:1));
	g.vector <- function(z,e) {
		g <- function (z,e) {(1-e) * dnorm(z) + e * dcauchy(z, scale=sqrt(2)) };
		return(prod(sapply(z,(function(x){4*g(x,e)})))) }  # 4 avoids underflow
	p <- rep(0,k);
	for(j in 1:k) { p[j] <- 2^{-j} * g.vector(z,eps[j]); }
	score <- function(z,e) {
		twopzz <- 2 + z*z; 	expZ <- exp(z*z/2);
		num <- -sqrt(pi)*twopzz^2 * (e-1) + 4*expZ*e;
		den <-  sqrt(pi)*twopzz   * (e-1) - 2*expZ*e;
		return((z*num)/(twopzz*den))	}
	p <- p / sum(p);
	scr <- outer(z,eps,score);
	zt <- as.vector(z + scr %*% p);
	zt[big.in]<-big;
	return(zt)
}